package org.eclipse.jdt.internal.compiler.apt.util;

package .tmp;

import org.eclipse.jdt.internal.compiler.apt.util.Util;

public class EncodingError {
  int position;
  
  int length;
  
  public EncodingError(int position, int length) {
    this.position = position;
    this.length = length;
  }
  
  public String getSource(char[] unitSource) {
    int startPosition = this.position;
    int endPosition = this.position + this.length - 1;
    if (startPosition > endPosition || (
      startPosition < 0 && endPosition < 0) || 
      unitSource.length == 0)
      return "No source available"; 
    StringBuffer errorBuffer = new StringBuffer();
    errorBuffer.append('\t');
    int sourceLength = unitSource.length;
    char c;
    int begin;
    for (begin = (startPosition >= sourceLength) ? (sourceLength - 1) : startPosition; begin > 0 && (
      c = unitSource[begin - 1]) != '\n' && c != '\r'; begin--);
    int end;
    for (end = (endPosition >= sourceLength) ? (sourceLength - 1) : endPosition; end + 1 < sourceLength && (
      c = unitSource[end + 1]) != '\r' && c != '\n'; end++);
    for (; (c = unitSource[begin]) == ' ' || c == '\t'; begin++);
    errorBuffer.append(unitSource, begin, end - begin + 1);
    errorBuffer.append(Util.LINE_SEPARATOR).append("\t");
    int i;
    for (i = begin; i < startPosition; i++)
      errorBuffer.append((unitSource[i] == '\t') ? 9 : 32); 
    for (i = startPosition; i <= ((endPosition >= sourceLength) ? (sourceLength - 1) : endPosition); i++)
      errorBuffer.append('^'); 
    return errorBuffer.toString();
  }
}
